<?php

use EuKit\Base\Parts\Concept;
use EuKit\Base\ViewModels\Teaser;
use Infomaker\Everyware\Twig\View;
use EuKit\Base\Parts\NewsMLArticle;
use EuKit\Base\ViewModels\ConceptPage;
use Infomaker\Everyware\Base\Models\Page;
use Infomaker\Everyware\Base\OpenContent\QueryBuilder;
use Infomaker\Everyware\Base\OpenContent\OpenContentProvider;

$current_page = Page::current();

if ($current_page instanceof Page) {
	$conceptPages = Concept::createFromPost($current_page);
	$conceptPage = new ConceptPage($conceptPages);
	$uuid = $conceptPage->getViewData()['uuid'];
	$query = QueryBuilder::where('ConceptUuids', $uuid)->andIfProperty('Status', 'usable');

	$provider = OpenContentProvider::setup([
		'q'                      => $query->buildQueryString(),
		'contenttypes'           => ['Article'],
		'sort.indexfield'        => 'Pubdate',
		'sort.Pubdate.ascending' => 'false',
		'limit'                  => 30,
		'start'                  => 0,
	]);

	$articles = $provider->queryWithRequirements();
	$teasers = [];

	if (is_array($articles)) {
		foreach ($articles as $key => $article) {
			if ($article instanceof OcArticle) {
				$newsmlArticle = NewsMLArticle::createfromOcObject($article);
				$teaser = new Teaser($newsmlArticle);

				$teasers[] = $teaser->getViewData();
			}
		}
	}
	$conceptPage->setViewData('articles', $teasers);

	View::render('@base/page/concept-page', $conceptPage->getViewData());
}
